var baseUrl = 'https://str8dispatch.com';
var apiBaseUrl = baseUrl + '/extension/api/';
var userId = '';

$('body').bind('DOMSubtreeModified', function(e) {
    if (e.target.innerHTML.length > 0) {
        var height = $(".tabs").outerHeight(true);
        $('body').height(height);
        $('html').height(height);
    }
});

$(document).ready(function() {
	
	$("#cur_year").text(new Date().getFullYear());
	
    $("input").on("keypress", function() {
        $(this).trigger('click');
    });

    /************ NavBar toggle*************/
    $("#navbarDropdown").on('click', function() {
        $(".dropdown-menu").toggle();
    });

    $("body").click(function(e) {
        adjustPopUpHeight();
        if (e.target.id == "main-wrapper" || $(e.target).parents("#main-wrapper").length) {
            $(".dropdown-menu").hide();
        }
    });

	
    $(".dropdown-menu .dropdown-item").on('click', function() {
        $(".dropdown-menu").hide();
    });
    /************ End NavBar toggle*************/

    dashboard();

    /********* To show login form *******/
    $(".mail-links").on('click', function() {
        var emailUrl = $(this).attr('href'); 
		chrome.extension.getBackgroundPage().sendEmail(emailUrl);	
    });
	
	$(".login-link").on('click', function() {
        $(".initial-tabs").hide();
        $(".Login").show();
    });

    /********* To show forgot password form *******/
    $("#forgot-pass-link").on('click', function() {
        $(".initial-tabs").hide();
        $(".forgot_password").show();
    });
	
    /********* Logout from extension *******/
    $("#logout-link").on('click', function() {		
        browser.storage.local.set({'user': ''});
        $('.tabs').hide();
        $('#tab1').show();
        message_animation('alert-success');
        $('.msg').text('You are now logged out');
		
		$.ajax({
			type: "POST",
			url: apiBaseUrl + "?action=logout",
			data: {userId:userId},
			dataType: 'json'
		}).done(function(response) {
		});
    });

    /********* Validate login form *******/
    $("#login_form").validate({
        rules: {
            email: {
                required: true
            }
        },
        messages: {
            email: {
                required: "License Key can not be empty"
            }
        },
        submitHandler: function() {
            login();
            return false;
        }
    });

    /********* Validate forgot password form *******/
    $("#forgot_password_form").validate({
        rules: {
            email: {
                required: true,
                email: true
            }
        },
        messages: {
            email: {
                required: "Email can not be empty",
                email: "Please enter valid email"
            }
        },
        submitHandler: function() {
            forgot_password();
            return false;
        }
    });

    /********* Validate LinkedIn features settings form *******/
    $("#settings_form").validate({
        rules: {
            min_per_mile: true,
			color: true
        },
        submitHandler: function() {
            updateSettings();
            return false;
        }
    });

})

/********* To check for login from database and show their respective messages *******/
function login() {
	browser.storage.local.get(["token"], function(result) {
		$.ajax({
			type: "POST",
			url: apiBaseUrl + "?action=login",
			data: {token:result.token,email:$('#login_form #email').val()},
			dataType: 'json'
		}).done(function(response) {
			if (response.status == 404) {
				message_animation('alert-danger');
				$('.msg').text(response.msg);
			} else {
				message_animation('alert-success');
				browser.storage.local.set({'user': response.user,'token':response.token});
				$('.msg').text(response.msg);
				dashboard();
				browser.runtime.setUninstallURL(baseUrl + '/extension/firefox-uninstall.php?key='+response.token);
			}
		});
	});    
}

/********* To send reset password link*******/
function forgot_password() {
    $.ajax({
        type: "POST",
        url: apiBaseUrl + "?action=resetPassword",
        data: $("#forgot_password_form").serialize(),
        dataType: 'json'
    }).done(function(response) {
        if (response.status == 404) {
            message_animation('alert-danger');
            $('.msg').text(response.msg);
        } else {
            message_animation('alert-success');
            $('.msg').text(response.msg);
            $("#forgot_password_form")[0].reset();
        }
    });
}

function updateSettings() {
    $.ajax({
        type: "POST",
        url: apiBaseUrl + "?action=updateSettings",
        data: $("#settings_form").serialize(),
        dataType: 'json'
    }).done(function(response) {
        if (response.status == 404) {
            $('.msg').text(response.msg);
            message_animation('alert-danger');
        } else {
            $('.msg').text(response.msg);
            message_animation('alert-success');
            browser.storage.local.get(["user"], function(result) {
                var temp = result.user;
                temp.min_per_mile = $("#min_per_mile").val();
                temp.color = $("#color").val(); 
				
				if($("#o_deadhead").is(':checked')) {
					temp.o_deadhead = 1;
				} else {
					temp.o_deadhead = 0;
				}

				if($("#d_deadhead").is(':checked')) {
					temp.d_deadhead = 1;
				} else {
					temp.d_deadhead = 0;
				}
				console.log(temp);
                browser.storage.local.set({'user': temp});
				chrome.tabs.query({
					active: true,
					currentWindow: true
				}, function(tabs) {
					chrome.tabs.sendMessage(tabs[0].id, {from: 'popup', subject: 'runFreightHelper'});
				});
				
            });
        }
    });
}

/********* To show response messages with animation *******/
function message_animation(addClass) {
    $('.msg').addClass("alert " + addClass);
    setTimeout(function() {
        $('.msg').removeClass("alert alert-danger alert-success");
        $('.msg').text('');
        adjustPopUpHeight();
    }, 2000);
}

function adjustPopUpHeight() {
    var height = $(".tabs").outerHeight(true);
    $('body').height(height);
    $('html').height(height);
}

/********* To update the extension popup pages *******/
function dashboard() {
    browser.storage.local.get(["user"], function(result) {
        if (typeof result.user != "undefined" && result.user != "") {
            $("#name").val(result.user.name);
            $(".userId").val(result.user.id);
			userId = result.user.id;
            $("#min_per_mile").val(result.user.min_per_mile);
            $("#color").val(result.user.color);		
			if(result.user.o_deadhead == 1){
				 $("#o_deadhead").attr('checked',true);
			}
			if(result.user.d_deadhead == 1){
				$("#d_deadhead").attr('checked',true);
			}
            $('.tabs').hide();
            $('#tab2').show().trigger('click');			
        }
    });
}


